/*global define, require, CKEDITOR, setTimeout*/
/*jslint regexp: true, unparam: true, nomen: true*/

// since jscoverage strips named defines, we mock the data directly as defined (in require.js)
require.s.contexts._.defined['de_epages/externalcontent/gadgetdialog/JSONGetGadgetInformation'] = {
    "GadgetGroups": [{
        "Alias": "Information",
        "Gadgets": [{
            "Alias": "RSS"
        }, {
            "Alias": "Maps"
        }, {
            "Alias": "Translation"
        }]
    }, {
        "Alias": "Multimedia",
        "Gadgets": [{
            "Alias": "ExternalVideo"
        }, {
            "Alias": "ContentSlider"
        }]
    }, {
        "Alias": "Social",
        "Gadgets": [{
            "Alias": "Facebook"
        }, {
            "Alias": "Twitter"
        }, {
            "Alias": "GooglePlus"
        }, {
            "Alias": "OtherButtons"
        }]
    }]
};

define(['testsuite/qunit', 'jquery', 'ep/ui/editor', '$ready!'], function (QUnit, $) {
    'use strict';

    QUnit.module("ckeditor/plugins/epgadget");

    var editor1 = $('#uieditor_ckeditortestinstance_test1');

    // Instantiate CKE.
    editor1.uiEditor({
        'name' : 'ckeditortestinstance_test1'
    });

    setTimeout(function () {

        QUnit.asyncTest("basic epgadget plugin tests", function () {
            var editorId = 'uieditor_ckeditortestinstance_test1',
                editorClass = 'cke_1',
                editorInstance = CKEDITOR.instances[editorId];

            // Reset CKE data.
            editorInstance.setData('');
            // Check if epgadget button exists.
            QUnit.equal($('.' + editorClass + ' .cke_button__epgadget').length, 1, 'the necessary epgadget button exists');
            // Open gadget dialog.
            $('.' + editorClass + ' .cke_button__epgadget').trigger('click');

            setTimeout(function () {
                var gadgetDialog = $('div.epDialog');

                QUnit.equal(gadgetDialog.length, 1, 'gadget dialog is open');
                QUnit.ok(gadgetDialog.find('li').length > 0, 'gadgets found.');

                gadgetDialog.find('li').eq(1).find('span').trigger('click');

                setTimeout(function () {
                    var buttonPane = $('div.uiDialogButtonPane > button');

                    QUnit.equal(buttonPane.length, 2, 'maps gadget dialog is open.');

                    buttonPane.eq(0).trigger('click');

                    setTimeout(function () {
                        var data = editorInstance.getData(),
                            fragment = $("<div />").html(data),
                            gadget = fragment.find('div.ep-gadget'),
                            fakeElement = $(editorInstance.document.$.body).find('img.ep-gadget');

                        QUnit.ok(fakeElement.length === 1, 'fakeElement to diaplay maps gadget in WYSIWYG was inserted');
                        QUnit.ok(gadget.length === 1, 'maps gadget was inserted to textarea');

                        QUnit.start();
                    }, 200);

                }, 500);

            }, 1000);

        });

    }, 2000);
});