/*global define*/
define('de_epages/externalcontent/gadgetdialog/facebook-view', [
    'jquery',
    './config-view',
    '$tmpl!./facebook-view',
    '$dict!../dictionary',

    '../ui/facebook' // The gadget to configure.
], function ($, ConfigView, template, dict) {
    'use strict';
    return ConfigView.extend({
        alias: 'facebook',
        dict: dict,
        events: ConfigView.events,
        template: template,
        onSelect: function (e, noPreview) {
            var target = e.target,
                selected = $(target).find(':selected');

            this.setOption(target.name, selected.val(), noPreview ? false : true);

            // show showFaces option only for standard layout
            if(selected.context.name === 'layout'){
                var showFaces = this.$('#showFaces'),
                    label = this.$('label[for="showFaces"]');

                if(selected.val() === 'standard'){
                    showFaces.attr({disabled: false});
                    label.removeClass('Disabled');
                }
                else{
                    showFaces.attr({disabled: true});
                    label.addClass('Disabled')
                }
            }
        }
    });
});